import tkinter as tk
import numpy as np
import QTM_Core as Cor
from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import (FigureCanvasTkAgg)
import os
import shutil
import QTM_TT_IO as TT
from tkinter import filedialog as fd
from scipy import stats

def Calc_ModelFreePars():
    global times,mDfbyns,Df_ratios,ff_ratios,PLExponts_Df_ratios,PLExponts_ff_ratios,lowest_iovt
    mDfbyns   = np.ones((Cor.novt,Cor.i_stop_fit-Cor.i_strt_fit))*np.nan
    Df_ratios = np.ones((Cor.novt,Cor.i_stop_fit-Cor.i_strt_fit))*np.nan
    ff_ratios = np.ones((Cor.novt,Cor.i_stop_fit-Cor.i_strt_fit))*np.nan
    times         = np.ones((Cor.i_stop_fit-Cor.i_strt_fit))*np.nan 
    PLExponts_Df_ratios = np.ones((Cor.i_stop_fit-Cor.i_strt_fit))*np.nan 
    PLExponts_ff_ratios = np.ones((Cor.i_stop_fit-Cor.i_strt_fit))*np.nan 
    lowest_iovt = 0
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1: 
            lowest_iovt = iovt
            break
    ns_Df_ratios = []
    ns_ff_ratios = []
    ovt_list_Df_ratios = []
    ovt_list_ff_ratios = []
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1: 
            ns_Df_ratios = np.append(ns_Df_ratios,Cor.n_arr[iovt])
            ns_ff_ratios = np.append(ns_ff_ratios,Cor.n_arr[iovt])
            ovt_list_Df_ratios = np.append(ovt_list_Df_ratios,iovt)
            ovt_list_ff_ratios = np.append(ovt_list_ff_ratios,iovt)
    ovt_list_Df_ratios = ovt_list_Df_ratios.astype(int)        
    ovt_list_ff_ratios = ovt_list_Df_ratios.astype(int)        
    n_act = len(ns_Df_ratios)
    ns_ff_ratios = ns_ff_ratios[1:]
    ovt_list_ff_ratios = ovt_list_ff_ratios[1:]
            
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1:
            mDfbyns[  iovt] =-TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,2+4*iovt]
            Df_ratios[iovt] =-TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,2+4*iovt+1]/\
                              TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,2+4*iovt]
            ff_ratios[iovt] = 1 - TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,2+4*iovt]/\
                                  TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,2+4*lowest_iovt]
            for it in range(len(Df_ratios[iovt])):
                if Df_ratios[iovt,it] > 10   : Df_ratios[iovt,it] = np.nan
                if ff_ratios[iovt,it] > 10   : ff_ratios[iovt,it] = np.nan
                if np.abs(Df_ratios[iovt,it]) < 1e-3 : Df_ratios[iovt,it] = np.nan
                if np.abs(ff_ratios[iovt,it]) < 1e-3 : ff_ratios[iovt,it] = np.nan
    count = 0
    for it in range(Cor.i_stop_fit-Cor.i_strt_fit):
        times[count] = TT.DfDGbyns[it,1]
        Df_ratios_for_PLexp = np.ones(n_act  )*np.nan
        ff_ratios_for_PLexp = np.ones(n_act-1)*np.nan
        for i in range(n_act):
            Df_ratios_for_PLexp[i] = Df_ratios[ovt_list_Df_ratios[i],it]
        for i in range(n_act-1):
            ff_ratios_for_PLexp[i] = ff_ratios[ovt_list_ff_ratios[i],it]
            
        PLExponts_Df_ratios[count], intercept, r_value, p_value, std_err = \
            stats.linregress(np.log(ns_Df_ratios),np.log(Df_ratios_for_PLexp))
        if np.average(ff_ratios_for_PLexp) > 0:     
            PLExponts_ff_ratios[count], intercept, r_value, p_value, std_err = \
                stats.linregress(np.log(ns_ff_ratios),np.log(ff_ratios_for_PLexp))
        else :        
            PLExponts_ff_ratios[count], intercept, r_value, p_value, std_err = \
                stats.linregress(np.log(ns_ff_ratios),np.log(-ff_ratios_for_PLexp))
        count += 1    
    dataout = [TT.DfDGbyns[Cor.i_strt_fit:Cor.i_stop_fit,1]]
    header = 'time \t'
    dataout = np.append(dataout,[PLExponts_Df_ratios],axis=0)
    dataout = np.append(dataout,[PLExponts_ff_ratios],axis=0)
    header = header + 'PLExponts_Df_ratios \t' 'PLExponts_ff_ratios \t'  
            
    for iovt,n in enumerate(Cor.n_arr):
        if Cor.OvtInc[iovt] == 1:
            header = header + 'mDfbyn' + str(int(n)) + '\t' + 'Df_ratios' + str(int(n)) + '\t'
            dataout = np.append(dataout,[mDfbyns[iovt],Df_ratios[iovt]],axis=0)
    for iovt,n in enumerate(Cor.n_arr):
        if Cor.OvtInc[iovt] == 1:
            header = header + 'mDfbyn_min' + str(int(n)) + '\t' + 'ff_ratios' + str(int(n)) + '\t'
            dataout = np.append(dataout,[mDfbyns[lowest_iovt],ff_ratios[iovt]],axis=0)
    np.savetxt(os.getcwd()+'/tmp/ModelFreePars.qt2',np.transpose(dataout),header=header,delimiter = '\t') 

def Plot_vs_mDfbyn(cntr):
    for widget in cntr.winfo_children(): widget.destroy()
    fig = Figure(figsize = (8,7))
    axis = fig.add_subplot(221)
    if np.ndim(TT.DfDGbyns) == 1: TT.DfDGbyns = np.array([TT.DfDGbyns])
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1:
            axis.plot(mDfbyns[iovt],Df_ratios[iovt],\
                '.',color=Cor.Colors[iovt],label = Cor.Ovt_Labels[iovt],markersize = 2.)
    axis.set_xlabel('$-\Delta f/n$ [Hz]',fontsize=9)
    axis.set_ylabel('$\Delta \Gamma/(-\Delta f)$',fontsize=9)
    axis.tick_params(direction='in',labelsize =8)
    if np.sum(Cor.OvtInc) > 0: axis.legend(fontsize=7)
  
    axis = fig.add_subplot(222)
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1:
            axis.plot(mDfbyns[lowest_iovt],ff_ratios[iovt],'.',color=Cor.Colors[iovt],markersize = 2.)
    axis.set_xlabel('$-\Delta f/n_{lowest}$ [Hz]',fontsize=9)
    axis.set_ylabel('$1-(\Delta f/n)/(\Delta f/n)_{min}$',fontsize=9)
    axis.tick_params(direction='in',labelsize=8)

    axis = fig.add_subplot(223)
    axis.plot(mDfbyns[lowest_iovt],PLExponts_Df_ratios,'.',markersize = 2.)
    axis.set_xlabel('$-\Delta f/n_{lowest}$ [Hz]',fontsize=9)
    axis.set_xlim(left = mDfbyns[lowest_iovt,0])
    axis.set_title('Power Law Exp.   [$\Delta \Gamma/(-\Delta f)$] vs. n',fontsize=9)

    axis = fig.add_subplot(224)
    axis.plot(mDfbyns[lowest_iovt],PLExponts_ff_ratios,'.',markersize = 2.)
    axis.set_xlabel('$-\Delta f/n_{lowest}$ [Hz]',fontsize=9)
    axis.set_title('Power Law Exp.   [$1-(\Delta f/n)/(\Delta f/n)_{min}$] vs. n',fontsize=9)
    axis.set_xlim(left = mDfbyns[lowest_iovt,0])

    suptitletext = ''
    if len(Cor.InfoString) > 0: 
        suptitletext += Cor.InfoString
    suptitletext +=  '\n' + os.path.basename(Cor.filename)[:55]
    fig.suptitle(suptitletext,fontsize = 8)
    fig.tight_layout(); fig.savefig(os.getcwd()+'/tmp/ModelFreePars_mDfbyn.png',dpi=200)

    canvas = FigureCanvasTkAgg(fig,cntr); canvas.draw(); 
    canvas.get_tk_widget().grid(row=0,column=0,columnspan=7,sticky='NW')

def Plot_vs_time(cntr):
    for widget in cntr.winfo_children(): widget.destroy()
    fig = Figure(figsize = (8,7))
    axis = fig.add_subplot(221)
    if np.ndim(TT.DfDGbyns) == 1: TT.DfDGbyns = np.array([TT.DfDGbyns])
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1:
            axis.plot(times,Df_ratios[iovt],\
                '.',color=Cor.Colors[iovt],label = Cor.Ovt_Labels[iovt],markersize = 2.)
    axis.set_ylabel('$\Delta \Gamma/(-\Delta f)$',fontsize=9)
    axis.set_xlabel('time ' + Cor.TimeLabel,fontsize=9)    
    axis.tick_params(direction='in',labelsize =8)
    if np.sum(Cor.OvtInc) > 0: axis.legend(fontsize=7)
  
    axis = fig.add_subplot(222)
    for iovt in range(Cor.novt):
        if Cor.OvtInc[iovt] == 1:
            axis.plot(times,ff_ratios[iovt],'.',color=Cor.Colors[iovt],markersize = 2.)
    axis.set_xlabel('time ' + Cor.TimeLabel,fontsize=9)    
    axis.set_ylabel('$1-(\Delta f/n)/(\Delta f/n)_{min}$',fontsize=9)
    axis.tick_params(direction='in',labelsize=8)

    axis = fig.add_subplot(223)
    axis.plot(times,PLExponts_Df_ratios,'.',markersize = 2.)
    axis.set_xlabel('time ' + Cor.TimeLabel,fontsize=9)    
    axis.set_title('Power Law Exp. $\Delta \Gamma/(-\Delta f)$',fontsize=9)
    axis.set_xlim(left = times[0])

    axis = fig.add_subplot(224)
    axis.plot(times,PLExponts_ff_ratios,'.',markersize = 2.)
    axis.set_xlabel('time ' + Cor.TimeLabel,fontsize=9)    
    axis.set_title('Power Law Exp. $1-(\Delta f/n)/(\Delta f/n)_{min}$',fontsize=9)
    axis.set_xlim(left = times[0])

    axis.tick_params(direction='in',labelsize=8)
    suptitletext = ''
    if len(Cor.InfoString) > 0: 
        suptitletext += Cor.InfoString
    suptitletext +=  '\n' + os.path.basename(Cor.filename)[:55]
    fig.suptitle(suptitletext,fontsize = 8)
    fig.tight_layout(); fig.savefig(os.getcwd()+'/tmp/ModelFreePars_time.png',dpi=200)

    canvas = FigureCanvasTkAgg(fig,cntr); canvas.draw(); 
    canvas.get_tk_widget().grid(row=0,column=0,columnspan=7,sticky='NW')

def Export():
    ExportFilepath = fd.asksaveasfilename(initialfile='test_'+ os.path.basename(Cor.TT_filename[:-4]),\
            filetypes=[("qtm file", ".qtm")])
    if ExportFilepath == '' : return
    Folder          = os.path.dirname( ExportFilepath)
    ExportFilepath2 = os.path.basename(ExportFilepath).replace('_Master','')
    ExportFilepath2 = ExportFilepath2.replace('.qtm','')

    if os.path.isfile(  os.getcwd()+'/tmp/ModelFreePars.qt2'):
        shutil.copyfile(os.getcwd()+'/tmp/ModelFreePars.qt2',\
                        Folder + '/' + ExportFilepath2 + '_' + 'ModelFreePars.qt2')
    if os.path.isfile(  os.getcwd()+'/tmp/ModelFreePars_mDfbyn.png'):
        shutil.copyfile(os.getcwd()+'/tmp/ModelFreePars_mDfbyn.png',\
                        Folder + '/' + ExportFilepath2 + '_' + 'ModelFreePars_mDfbyn.png')
    if os.path.isfile(  os.getcwd()+'/tmp/ModelFreePars_time.png'):
        shutil.copyfile(os.getcwd()+'/tmp/ModelFreePars_time.png',\
                        Folder + '/' + ExportFilepath2 + '_' + 'ModelFreePars_time.png')

def ModelFreePars_Start():
    global Plots_vs_mDfbynFrame,Plots_vs_timeFrame,ModelFreeParsRoot

    ModelFreeParsRoot = tk.Tk(); ModelFreeParsRoot.title('Model free parameters')
    Calc_ModelFreePars()
    Plots_vs_mDfbynFrame = tk.LabelFrame(ModelFreeParsRoot); 
    Plots_vs_mDfbynFrame.grid(row=0,column=0,sticky = 'NW') 
    Plot_vs_mDfbyn(Plots_vs_mDfbynFrame)
    Plots_vs_timeFrame = tk.LabelFrame(ModelFreeParsRoot); 
    Plots_vs_timeFrame.grid(row=0,column=1,sticky = 'NW') 
    Plot_vs_time(Plots_vs_timeFrame)

    menubar = tk.Menu(ModelFreeParsRoot); ModelFreeParsRoot.config(menu=menubar) 
    menubar.add_command(label='Export',command=Export)
    ModelFreeParsRoot.iconbitmap("QTM.ico")
    ModelFreeParsRoot.mainloop()